/// <reference types="node" />
import { TSDateForm } from "./tsdatecomp";
import { int, uint, email, url, UUID, isodate, Address, AnyDictionary } from "./types";
import { TSData } from "./tsdata";
import { TSDate } from "./tsdate";
export declare function $defined(o: any): boolean;
export declare function $ok(o: any): boolean;
export declare function $value<T>(o: T | null | undefined, v: T): T;
export declare function $isstring(o: any): boolean;
export declare function $isnumber(o: any): boolean;
export declare function $isint(o: any): boolean;
export declare function $isunsigned(o: any, maximum?: number): boolean;
export declare function $isbool(o: any): boolean;
export declare function $isobject(o: any): boolean;
export declare function $objectcount(o: any): number;
export declare function $isarray(o: any): boolean;
export declare function $isiterable(o: any): boolean;
export declare function $isdate(o: any): boolean;
export declare function $isemail(o: any): boolean;
export declare function $isurl(o: any, opts?: $urlOptions): boolean;
export declare function $isuuid(o: any): boolean;
export declare function $isfunction(o: any): boolean;
export declare function $intornull(n: string | number | null | undefined): int | null;
export declare function $int(n: string | number | null | undefined, defaultValue?: int): int;
export declare function $email(s: string | null | undefined): email | null;
export interface $urlOptions {
    acceptsProtocolRelativeUrl?: boolean;
    acceptedProtocols?: string[];
}
export declare function $url(s: string | null | undefined, opts?: $urlOptions): url | null;
export declare function $UUID(s: string | null | undefined): UUID | null;
export declare type IsoDateFormat = TSDateForm.ISO8601C | TSDateForm.ISO8601L | TSDateForm.ISO8601;
export declare function $isodate(s: Date | TSDate | string | null | undefined, format?: IsoDateFormat): isodate | null;
export declare function $address(a: Address | null | undefined): Address | null;
export declare function $unsignedornull(n: string | number | null | undefined): uint | null;
export declare function $unsigned(n: string | number | null | undefined, defaultValue?: uint): uint;
export declare function $div(a: number, b: number): number;
export declare function $string(v: any): string;
export declare function $strings(v: string[] | string | undefined | null): string[];
export declare function $totype<T>(v: any): T | null;
export declare function $trim(s: string | undefined | null): string;
export declare function $fpad2(v: uint): string;
export declare function $fpad3(v: uint): string;
export declare function $fpad4(v: uint): string;
export declare function $fpad(v: uint, pad: number): string;
export declare function $ascii(source: string | undefined | null): string;
export declare function $capacityForCount(count: uint): uint;
export declare function $count(a: any[] | Uint8Array | undefined | null): number;
export declare function $length(s: string | Uint8Array | TSData | undefined | null): number;
export declare function $lengthin(s: string | Uint8Array | TSData | undefined | null, min?: number, max?: number): boolean;
export declare function $arraybuffer(buf: Buffer): ArrayBuffer;
export declare function $map<T, R = T>(values: Iterable<T> | undefined | null, callBack: (e: T) => R | null | undefined): Array<R>;
export declare function $jsonobj(v: any): any;
export declare function $keys<T>(o: T | undefined | null): Array<keyof T>;
export interface $partialOptions<T, U> {
    properties?: Array<keyof T | keyof U>;
    filter?: (v: T[keyof T]) => T[keyof T] | U[keyof U] | undefined;
}
export declare function $partial<T, U>(a: T | undefined | null, opts?: $partialOptions<T, U>): [U, number];
export declare function $dict(source: object | null | undefined, keys?: string[]): AnyDictionary;
export declare function $includesdict(source: object | null | undefined, dict: AnyDictionary, keys?: string[]): boolean;
export interface $fusionOptions<T, U> {
    A?: $partialOptions<T, U>;
    B?: $partialOptions<T, U>;
    fusionArrays?: (a: Array<any>, b: Array<any>) => Array<any>;
    fusionObjects?: (a: object, b: object) => object;
}
export declare function $fusion<T, U>(a: T | undefined | null, b: U | undefined | null, opts?: $fusionOptions<T, U>): [Partial<T> & Partial<U>, number];
export declare function $json(v: any, replacer?: (number | string)[] | null, space?: string | number): string;
declare global {
    export interface Array<T> {
        filteredMap: <R = T>(callBack: (e: T) => R | null | undefined) => Array<R>;
    }
}
