/// <reference types="node" />
/// <reference types="node" />
import { IncomingMessage, ServerResponse } from "http";
import { StringDictionary, uint32 } from "./types";
import { Verb } from "./tsrequest";
import { TSEndPoints, TSServerLogger } from "./tsserver";
export interface TSStaticWebSiteOptions {
    logger?: TSServerLogger;
    managedTypes?: StringDictionary;
    maxCacheSize?: uint32;
    maxCachedFileSize?: uint32;
    maxCachedFiles?: uint32;
    maxBlacklistedFiles?: uint32;
}
export declare class TSStaticWebsite {
    readonly uri: string;
    readonly folder: string;
    private _cache;
    private _cacheMemory;
    private _blacklisted;
    private _opts;
    constructor(uri: string, folder: string, opts: TSStaticWebSiteOptions);
    getStaticResource(uri: string): [Buffer | undefined | null, string];
    clearCaches(): Promise<void>;
    private _cacheContent;
    private _blacklist;
    private static readonly __TSServerStandardsTypes;
}
export declare class TSParametricEndPoints {
    readonly uri: string;
    readonly depth: number;
    readonly tokens: string[];
    readonly endPoints: TSEndPoints;
    readonly caseInsensitive: boolean;
    private _regex;
    private _tlen;
    private static __verbs;
    static validRequestMethod(method: string | undefined | null): Verb | null;
    constructor(path: string, ep: TSEndPoints, caseInsensitive?: boolean);
    get static(): boolean;
    execute(url: URL, method: Verb, parameters: StringDictionary, req: IncomingMessage, res: ServerResponse): Promise<void>;
    valuesFromPath(path: string): StringDictionary | null;
}
